﻿<?php

//Functions

function user_date_selector($offset) {
	$user_offset = ($offset * 60 * 60);
	$start = '<option value="' . $offset . '"';
	if ((gmdate("d/m/Y H:i", time() + $user_offset)) == gmdate("d/m/Y H:i")) {
		$selected = ' selected="selected"';
	}
	$output = $start . $selected . '>'.gmdate("d/m/Y H:i", time() + $user_offset).'</option>';
	return $output;
}

function connect_config() {
	global $square_version;
	include('../config.php');

	if (VERSION <> $square_version) {
		return "fail";
	} else {
		return "pass";
	}
}

function run_prologue($fail = false) {
	global $header, $footer, $square_version;

	echo $header;
	echo '
	<h1>Square CMS '.$square_version.'</h1>
	<p>Welcome to the Square CMS, your free (as a bird), lightweight and free (as in beer) PHP and MySQL content management system.</p>
	<p>Before we begin, please read the following terms as laid out in the license and hit next.</p>
		<div class="agreement">
		<h2><strong>Square</strong> CMS Version '.$square_version.'</h2>
		<p>More information available at <a href="http://spoolio.co.cc/p/square/" target="_blank">http://spoolio.co.cc/p/square/</a><br />
		(Last Updated June 15th 2010)</p>
		<p></p>
		<p>You <span class="cannot">can\'t:</span>
		<ul>
			<li>redistribute this software with <strong>profit</strong> in mind. <strong>Ever</strong>. Permission won\'t be given either.</li>
		</ul></p>
		<p></p>
		<p>You <span class="can">can</span>:
		<ul>
			<li>use Square for any use you see fit.</li>
			<li>make copies of the software <strong>for any means necessary</strong>.</li>
			<li>redistrubute the software for <strong>non-profit</strong> purposes (Gift Square to a loved one!)</li>
			<li>edit the code in any way you see fit and redistribute said code as long as you <strong>give credit</strong> (or just get in touch).</li>
		</ul></p>
		<p>Square CMS contains portions of code not created by me (Thomas Chatting), these have been labelled as "alien" where appropriate, if you do see you\'re own code in the system and want it removed or want the credit you deserve. <strong>Get in touch</strong>.</p>
	</div>
	<form method="post" action="./">';
	if ($fail) {
		echo '<p class="fail" id="centre">You failed to accept the license terms. Installation cannot continue until you do so.</p>';
	}
	echo '		<p id="centre"><input type="checkbox" class="checkbox" name="agree" value="agree" />I agree that if I violate the terms above, I will be shot at dawn.</p>
		<input type="hidden" name="step" value="checklicense" />
		<button name="terms" type="submit" value="submit" class="right">Next</button>
	</form>
	';
	echo $footer;
}

function check_compatibility($progress = "pending") {
	if (isset($_POST["auth"])) {
		$host = $_POST["server"];
		$database = $_POST["database"];
		$user = $_POST["username"];
		$pass = $_POST["password"];
		$prefix = $_POST["prefix"];
		$link = mysql_connect($host,$user,$pass);
		$dbcheck = mysql_select_db("$database");
		$progress = "pass";
		if (!$link) {
			$progress = "fail";
		} else {
			if (!$dbcheck) {
				$progress = "fail";
			}
		}
		mysql_close($link);
	}
	global $header, $footer, $square_version;
	echo $header;
	echo '<h1>Compatibility Test</h1>
	<p>Before we install Square, we need to check the compatibility of the software on your server.</p>
	<ul class="test">
		<li class="'.phpversiontest().'">'; if (phpversiontest() == "warning") { echo '<span class="info">This version of PHP has not been tested with Square, please upgrade if you suffer problems</span>';} else {echo "Your PHP version is supported by Square"; } echo '</li>
		<li class="'.check_latest_version().'">'; if (check_latest_version() == "pass") { echo "This is the latest version of Square available!"; } elseif (check_latest_version() == "warning") { echo "Unable to determine if this is a current version of Square, check <a href='http://spoolio.co.cc/p/square'>here</a> to make sure"; } else { echo '<span class="info">This is not the most recent version of Square, check <a href="http://spoolio.co.cc/p/square">here</a> to download the latest and greatest</span>'; } echo'</li>
		<li class="'.$progress.'">'; if ($progress == "pending") { echo "Square requires a MySQL database with valid connection credentials to be able to run even its\' most basic of functionality, please provide your credentials below and I will test them."; } if ($progress == "fail") { echo '<span class="info">I was unable to connect to your mysql database using the credentials provided: '.mysql_error().'</span>';} if ($progress == "pass") { echo 'Successfully connected to your MySQL database!'; } echo '</li>
	</ul>
	<hr /> ';
	if ($progress <> "pass") {
	echo '
	<form method="post" action="./" class="server">
		<input type="hidden" name="step" value="checklicense" />
		<input type="hidden" name="agree" value="agree" />
		<label for="server">Server:</label><input type="text" name="server" value="localhost" id="server" />
		<hr />
		<label for="database">Database:</label><input type="text" name="database" value="database" id="database" />
		<hr />
		<label for="username">Username:</label><input type="text" name="username" id="username" />
		<hr />
		<label for="password">Password:</label><input type="password" name="password" id="password" />
		<hr />
		<label for="prefix">Prefix:</label><input type="text" name="prefix" value="square_" id="prefix" />
		<hr />
		<button name="auth" type="submit" value="test" class="right">Authenticate</button>
	</form>
	'; } else {
	echo '
	<form method="post" action="./">
		<input type="hidden" name="server" value="'.$host.'" />
		<input type="hidden" name="username" value="'.$user.'" />
		<input type="hidden" name="password" value="'.$pass.'" />
		<input type="hidden" name="prefix" value="'.$prefix.'" />
		<input type="hidden" name="database" value="'.$database.'" />
		<input type="hidden" name="step" value="checkcurrentstatus" />
		<button name="checkcurrentstatus" type="submit" value="next" class="right">Continue</button>
	</form>
	';
	}
	echo $footer;
}

function phpversiontest() {
	if (!defined('PHP_VERSION_ID')) {
		$version = explode('.', PHP_VERSION);

		define('PHP_VERSION_ID', ($version[0] * 10000 + $version[1] * 100 + $version[2]));
	}
	if (PHP_VERSION_ID > 40101) {
		return "pass";
	} else {
		return "warning";
	}
}

function check_latest_version() {
	global $square_version;
	if ($str = http_get_file('http://spoolio.po.gs/current.txt')){
		$onversion = explode('.',$str);
		$offversion = explode('.',$square_version);
		if (intval($onversion[0]) <> intval($offversion[0])){
			return "fail";
			exit();
		}
		if (intval($onversion[1].$onversion[2]) > intval($offversion[1].$offversion[2])){
			return "fail";
			exit();
		}
		return "pass";
	} else {
		return "warning";
	}
}

function http_get_file($url)    {
	$url_stuff = parse_url($url);
	$port = isset($url_stuff['port']) ? $url_stuff['port']:80;

	$fp = fsockopen($url_stuff['host'], $port);

	$query  = 'GET ' . $url_stuff['path'] . " HTTP/1.0\n";
	$query .= 'Host: ' . $url_stuff['host'];
	$query .= "\n\n";

	fwrite($fp, $query);

	while ($line = fread($fp, 1024)) {
		$buffer .= $line;
	}

	preg_match('/Content-Length: ([0-9]+)/', $buffer, $parts);
	return substr($buffer, - $parts[1]);
}

function fail() {
	global $footer;
	echo '<span class="fail">Oops, looks like the install failed due to some unforeseen reason, feel free to try again or send a support request with any debugging information you see.</span>';
	echo mysql_error;
	echo $footer;
	exit();
}

function generate_config($server, $database, $username, $password, $prefix) {
	global $square_version;
	return "<?php if (end(explode('/', \$_SERVER['PHP_SELF'])) == 'config.php') { die('No direct access allowed.'); }


	/*
		The above line makes sure people can't view this file directly, you'll see it in a lot
		of places in the system
	*/

	define('VERSION',		'".$square_version."');

	// MySQL SETTINGS
	\$dbhost 	= '".$server."';
	\$dbuser 	= '".$username."';
	\$dbpass 	= '".$password."';
	\$dbname 	= '".$database."';
	\$dbprefix 	= '".$prefix."';

	// LEAVE AS IS
	\$posts 		= \$dbprefix.'posts';
	\$trash 		= \$dbprefix.'posts_trash';
	\$pages 		= \$dbprefix.'pages';
	\$settings 	= \$dbprefix.'settings';

	\$order = 'ORDER BY `date-time` DESC, ID DESC';
	\$connection = mysql_connect(\$dbhost, \$dbuser, \$dbpass) or die (mysql_error());
	mysql_select_db(\$dbname);

	\$query = mysql_query(\"SELECT * FROM \$settings WHERE id = '1'\");
	\$setting = mysql_fetch_array(\$query, MYSQL_ASSOC);

	error_reporting(0);

	// LOGIN
	define('USERNAME',	\$setting['username']);
	define('PASSWORD',	\$setting['password']);

	// YOUR SITES NAME
	define('SITE_NAME',	\$setting['site_name']);
	define('TAGLINE',	\$setting['tagline']);

	/*
	This is the PHP format of the date, you can find a date format which suits
		you in the settings page, or by putting it in manually here using this page
		http://php.net/date
	*/
	\$date_format 	= \$setting['date_format'];
	\$timezone	 	= \$setting['timezone'];		// The UCT Offset
	\$uct_offset		= ((\$timezone) * 60 * 60);


	// COMMENTING
	if (\$setting['commenting_enabled'] == \"true\"){\$commenting_enabled = true;}else{\$commenting_enabled = false;}
	if (\$commenting_enabled == true) {
		\$comment_system = \$setting['comment_system']; // Disqus or Intense Debate
		\$comment_unique_id = \$setting['comment_unique_id'];
	}

	// FINE AS IS (UNLESS YOU KNOW OTHERWISE)
	if(\$setting['cleanurls'] == \"true\") {\$cleanurls=true;}else{\$cleanurls=false;}
	define('COOKIE_SALT',	'BB3154R4TH3RG00DBL0G3NG1N3');

	// ABSOLUTE DOMAIN
	define('DOMAIN', 	preg_replace('#^www\.#', '', \$_SERVER['SERVER_NAME']));
	\$tempurl =			str_replace('index.php', '', 'http://'.DOMAIN.\$_SERVER['PHP_SELF']);
	define('URL', 		str_replace('post.php', '', \$tempurl));

	// THEME SETTINGS
	\$theme = \$setting['theme'];
	\$theme_dir = './square/themes/'.\$theme.'/';

	// NOMOMOM - COOKIES
	define('COOKIE_NAME', 	'square_auth');
	define('COOKIE_VALUE', 	md5(USERNAME.PASSWORD.COOKIE_SALT));
	define('COOKIE_DOMAIN',	'.'.DOMAIN);
	define('NOW',			time());
	define('WEEK',			(24 * 60 * 60) * 7 );

	mysql_close(\$connection);";
}

// clean_install($server, $database, $username, $password, $prefix);
function clean_install($server, $database, $username, $password, $prefix) {
	global $header, $footer, $square_version, $config;

	$config = generate_config($server, $database, $username, $password, $prefix);
	$file = "../config.temp.php";
	$handle = fopen($file, 'a');
	fwrite($handle, $config);
	fclose($handle);
	rename("../config.temp.php", "../config.php");

	echo $header;
	echo '<script language="JavaScript">function highlight(field) {field.focus();field.select();}</script>
	<h1>Configuration File</h1>
	<p>Using the details you provided, I have attempted to create a configuration file in /square/config.php.</p>';
	if (file_exists('../config.php')) {
		echo '<p><span class="pass">Config.php created successfully, you can now move onto the next step</span></p>';
	} else {
		echo '<p><span class="fail">Config.php was not created, please create it manually.</span></p>';
	}
	echo '<p>If the creation was unsuccessful, please manually create this file using the data in the textbox below:</p>
	<textarea name="config.php" id="config" readonly="readonly" onClick="highlight(this);">'.$config.'</textarea>
	<form method="post" action="./">
		<input type="hidden" name="step" value="cleandatabasecreation" />
		<button name="next" type="submit" value="next" class="right">Next Step</button>
	</form>
	';
	echo $footer;
	exit();
}

function upgrade($server, $database, $username, $password, $prefix) {
	// We'll assume the user is on 0.2.2, but we need to support beta testers
	global $header, $footer, $square_version, $config;

	$config = generate_config($server, $database, $username, $password, $prefix);
	$file = "../config.temp.php";
	$handle = fopen($file, 'a');
	fwrite($handle, $config);
	fclose($handle);
	rename("../config.temp.php", "../config.php");

	echo $header;
	echo '<script language="JavaScript">function highlight(field) {field.focus();field.select();}</script>
	<h1>Configuration File</h1>
	<p>Using the details you provided, I have attempted to create a configuration file in /square/config.php.</p>';
	if (file_exists('../config.php')) {
		echo '<p><span class="pass">Config.php created successfully, you can now move onto the next step</span></p>';
	} else {
		echo '<p><span class="fail">Config.php was not created, please create it manually.</span></p>';
	}
	echo '<p>If the creation was unsuccessful, please manually create this file using the data in the textbox below:</p>
	<textarea name="config.php" id="config" readonly="readonly" onClick="highlight(this);">'.$config.'</textarea>
	<form method="post" action="./">
		<input type="hidden" name="step" value="databaseupdate" />
		<button name="next" type="submit" value="next" class="right">Next Step</button>
	</form>
	';
	echo $footer;
	exit();
}

/* backup the db OR just a table */
function backup_tables($host,$user,$pass,$name,$tables = '*')
{
	$link = mysql_connect($host,$user,$pass);
	mysql_select_db($name,$link);

	//get all of the tables
	if($tables == '*')
	{
		$tables = array();
		$result = mysql_query('SHOW TABLES');
		while($row = mysql_fetch_row($result))
		{
			$tables[] = $row[0];
		}
	}
	else
	{
		$tables = is_array($tables) ? $tables : explode(',',$tables);
	}

	//cycle through
	foreach($tables as $table)
	{
		$result = mysql_query('SELECT * FROM '.$table);
		$num_fields = mysql_num_fields($result);

		$return.= 'DROP TABLE '.$table.';';
		$row2 = mysql_fetch_row(mysql_query('SHOW CREATE TABLE '.$table));
		$return.= "\n\n".$row2[1].";\n\n";

		for ($i = 0; $i < $num_fields; $i++) 
		{
			while($row = mysql_fetch_row($result))
			{
				$return.= 'INSERT INTO '.$table.' VALUES(';
				for($j=0; $j<$num_fields; $j++) 
				{
					$row[$j] = addslashes($row[$j]);
					$row[$j] = ereg_replace("\n","\\n",$row[$j]);
					if (isset($row[$j])) { $return.= "'".$row[$j]."'" ; } else { $return.= '""'; }
					if ($j<($num_fields-1)) { $return.= ','; }
				}
				$return.= ");\n";
			}
		}
		$return.="\n\n\n";
	}

	//save file
	$filename = 'db-backup-'.time().'-'.(md5(implode(',',$tables))).'.sql';
	$handle = fopen($filename,'w+');
	fwrite($handle,$return);
	fclose($handle);

	return $filename;
}

function findColumn($database, $tableName, $columnName){
	$result = mysql_query('select * from '.$tableName.' limit 0,1');
	$columns = mysql_num_fields($result);

	for ($i = 0; $i < $columns; $i++) {
		$field_array[] = mysql_field_name($result, $i);
	}
	
	if (!in_array($columnName, $field_array)) {
		return false;
	} else {
		return true;
	}
}